// #include "LidarPerception_GeneralWrapper.h"
// #include "ara/log/logging.h"
#include "MOT_Wrapper.h"
#include "track.h"
using namespace lidar_tracker;
#define TUEOBJFUSN_ERROR_NOERROR true

// distance between front bumper and rear axcel

// mot::SLAMLocalEgoOdom vehicle_odom_vec;
// SLAMDataBuffer buffer(50); // store for 5 seconds (default timestamp is 100 ms)
// void input_wrapper(dpc::SLAMLocalEgoOdom* vehicle_odom_vec_Temp, mot::SLAMLocalEgoOdom* vehicle_odom_vec);
// uint32_t Kinematics_Relative2OverGround(mot::SLAMLocalEgoOdom* vehicle_odom_vec,
//    LidarPerceptionOutput* pCurrTrkbl, const float f32deltaX);
// double Main_MOT_Wrapper(std::vector<LidarPerceptionOutput>* Det_Objs, dpc::SLAMLocalEgoOdom &vehicle_odom_vec_Temp){
//     Usuccess = false;

//     input_wrapper(&vehicle_odom_vec_Temp, &vehicle_odom_vec);

//     buffer.addData(vehicle_odom_vec);
//     buffer.getInterpolatedData(0.0, &vehicle_odom_vec);
//     // Check if the pointer is valid (not null) before dereferencing.
//     if (Det_Objs != nullptr) {

//         for (LidarPerceptionOutput& Det_Obj : *Det_Objs) {

//             Usuccess = Kinematics_Relative2OverGround(&vehicle_odom_vec, &Det_Obj, f32deltaX);
//         }
//     }
//     return vehicle_odom_vec.ego_odom_time_ns;
// }

// Function to transfer ego data
// void input_wrapper(dpc::SLAMLocalEgoOdom* vehicle_odom_vec_Temp, mot::SLAMLocalEgoOdom* vehicle_odom_vec) {
//     vehicle_odom_vec->ego_odom_time_ns  = vehicle_odom_vec_Temp->ego_odom_time_ns;
//     vehicle_odom_vec->status_inf = vehicle_odom_vec_Temp->status_inf;
//     vehicle_odom_vec->origin_id = vehicle_odom_vec_Temp->origin_id;
//     vehicle_odom_vec->yaw = vehicle_odom_vec_Temp->yaw;
//     vehicle_odom_vec->position.x = vehicle_odom_vec_Temp->position.x;
//     vehicle_odom_vec->position.y = vehicle_odom_vec_Temp->position.y;
//     vehicle_odom_vec->position.z = vehicle_odom_vec_Temp->position.z;
//     vehicle_odom_vec->linear_velocity.x = vehicle_odom_vec_Temp->linear_velocity.x;
//     vehicle_odom_vec->linear_velocity.y = vehicle_odom_vec_Temp->linear_velocity.y;
//     vehicle_odom_vec->linear_velocity.z = vehicle_odom_vec_Temp->linear_velocity.z;
//     vehicle_odom_vec->yaw_rate = 0.0;
// }

// Function to transform coordinates

void output_wrapper(std::vector<perception::LiDARPerception2Fusion> &MOT_output_objs, std::vector<TrackPtr> &Track_List)
{

    perception::LiDARPerception2Fusion MOT_output_obj;
    for (uint16_t i = 0; i < Track_List.size(); i++)
    {
        MOT_output_obj.position.x = Track_List.at(i)->track_state.estimator.x();
        MOT_output_obj.position.y = Track_List.at(i)->track_state.estimator.y();
        MOT_output_obj.position.z = 0.0;
        MOT_output_obj.theta = 0;
        MOT_output_obj.length = Track_List.at(i)->track_state.bounding_box.length();
        MOT_output_obj.width = Track_List.at(i)->track_state.bounding_box.width();
        MOT_output_obj.height = 0.0;
        MOT_output_obj.velocity.x = Track_List.at(i)->track_state.estimator.vx();
        MOT_output_obj.velocity.y = Track_List.at(i)->track_state.estimator.vy();
        MOT_output_obj.velocity.z = 0.0;
        MOT_output_obj.type = Track_List.at(i)->track_state.type;
        MOT_output_obj.subtype = 0u;
        MOT_output_obj.confidence = 1.0;
        MOT_output_obj.ID = Track_List.at(i)->track_state.id;
        MOT_output_obj.timestamp = Track_List.at(i)->track_state.timestamp;
        MOT_output_obj.measurement_time = Track_List.at(i)->track_state.timestamp;
        MOT_output_obj.acceleration = {0.0, 0.0, 0.0};
        MOT_output_obj.position_covariance = {0.0, 0.0, 0.0};
        MOT_output_obj.velocity_covariance = {0.0, 0.0, 0.0};
        MOT_output_obj.acceleration_covariance = {0.0, 0.0, 0.0};
        MOT_output_objs.push_back(MOT_output_obj);
    }
    return;
}
void Kinematics_local2overground(std::vector<perception::LiDARPerception2Fusion> &MOT_output_objs, dpc::SLAMLocalEgoOdom *vehicle_odom_vec_Temp)
{
    for (uint16_t i = 0; i < MOT_output_objs.size(); i++)
    {
        MOT_output_objs.at(i).position.x -= vehicle_odom_vec_Temp->position.x;
        MOT_output_objs.at(i).position.y -= vehicle_odom_vec_Temp->position.y;
        MOT_output_objs.at(i).velocity.x -= vehicle_odom_vec_Temp->linear_velocity.x;
        MOT_output_objs.at(i).velocity.y -= vehicle_odom_vec_Temp->linear_velocity.y;
        MOT_output_objs.at(i).theta -= vehicle_odom_vec_Temp->yaw;
    }
}
mot::SLAMDataBuffer::SLAMDataBuffer(size_t capacity) : buffer(capacity), head(0), size(0)
{
}

void mot::SLAMDataBuffer::addData(const mot::SLAMLocalEgoOdom &data)
{
    buffer[head] = data;
    head = (head + 1) % buffer.size();
    size = std::min(size + 1, buffer.size());
}

std::pair<size_t, size_t> mot::SLAMDataBuffer::findInterpolationPoints()
{
    // Ensure the buffer has enough data
    if (size < 2)
    {
        throw std::runtime_error("Not enough data in the buffer for interpolation.");
    }

    // Find the two data points surrounding the target time
    size_t i = (head - size + buffer.size()) % buffer.size(); // Start from the oldest data
    while (i != head && buffer[i].ego_odom_time_ns <= targetTime)
    {
        i = (i + 1) % buffer.size();
    }
    size_t prevIndex = (i - 1 + buffer.size()) % buffer.size();

    return {prevIndex, i};
}

void mot::SLAMDataBuffer::interpolate(
    const mot::SLAMLocalEgoOdom &before,
    const mot::SLAMLocalEgoOdom &after,
    mot::SLAMLocalEgoOdom *result) const
{
    double fraction = (targetTime - before.ego_odom_time_ns) / (after.ego_odom_time_ns - before.ego_odom_time_ns);
    result->ego_odom_time_ns = targetTime;

    // Interpolate scalar values (yaw, yaw_rate)
    result->yaw = before.yaw + fraction * (after.yaw - before.yaw);
    result->yaw_rate = before.yaw_rate + fraction * (after.yaw_rate - before.yaw_rate);

    // Interpolate Vector3f elements
    result->position.x = before.position.x + fraction * (after.position.x - before.position.x);
    result->position.y = before.position.y + fraction * (after.position.y - before.position.y);
    result->position.z = before.position.z + fraction * (after.position.z - before.position.z);

    result->linear_velocity.x = before.linear_velocity.x + fraction * (after.linear_velocity.x - before.linear_velocity.x);
    result->linear_velocity.y = before.linear_velocity.y + fraction * (after.linear_velocity.y - before.linear_velocity.y);
    result->linear_velocity.z = before.linear_velocity.z + fraction * (after.linear_velocity.z - before.linear_velocity.z);

    // ... interpolate other data members if needed (status_inf, origin_id)
}

void mot::SLAMDataBuffer::getInterpolatedData(double *time, mot::SLAMLocalEgoOdom *interpolatedData)
{
    targetTime = *time;
    try
    {
        auto [before, after] = findInterpolationPoints();
        interpolate(buffer[before], buffer[after], interpolatedData);
    }
    catch (const std::runtime_error &e)
    {
        std::cerr << "Error: " << e.what() << std::endl;
    }
}

mot::InputWrapper::InputWrapper(size_t bufferSize) : buffer{bufferSize},
                                                     Usuccess{false}, f32deltaX{0.0f}
{
}

void mot::InputWrapper::_wrapper(dpc::SLAMLocalEgoOdom *vehicle_odom_vec_Temp, mot::SLAMLocalEgoOdom *vehicle_odom_vec)
{
    vehicle_odom_vec->ego_odom_time_ns = vehicle_odom_vec_Temp->ego_odom_time_ns;
    vehicle_odom_vec->status_inf = vehicle_odom_vec_Temp->status_inf;
    vehicle_odom_vec->origin_id = vehicle_odom_vec_Temp->origin_id;
    vehicle_odom_vec->yaw = vehicle_odom_vec_Temp->yaw;
    vehicle_odom_vec->position.x = vehicle_odom_vec_Temp->position.x;
    vehicle_odom_vec->position.y = vehicle_odom_vec_Temp->position.y;
    vehicle_odom_vec->position.z = vehicle_odom_vec_Temp->position.z;
    vehicle_odom_vec->linear_velocity.x = vehicle_odom_vec_Temp->linear_velocity.x;
    vehicle_odom_vec->linear_velocity.y = vehicle_odom_vec_Temp->linear_velocity.y;
    vehicle_odom_vec->linear_velocity.z = vehicle_odom_vec_Temp->linear_velocity.z;
    vehicle_odom_vec->yaw_rate = 0.0;
}

// void mot::InputWrapper::MotWrapper(std::vector<LidarPerceptionOutput>* Det_Objs, dpc::SLAMLocalEgoOdom &vehicle_odom_vec_Temp, double time) {
//     _wrapper(&vehicle_odom_vec_Temp, &vehicle_odom_vec);

//     buffer.addData(vehicle_odom_vec);
//     buffer.getInterpolatedData(&time, &vehicle_odom_vec);
//     // Check if the pointer is valid (not null) before dereferencing.
//     if (Det_Objs != nullptr) {
//         for (LidarPerceptionOutput& Det_Obj : *Det_Objs) {
//             Usuccess = Kinematics_Relative2OverGround(&vehicle_odom_vec, &Det_Obj, f32deltaX);
//         }
//     }
//     return;
// }

void mot::InputWrapper::MotWrapper(Eigen::MatrixXf &bboxes_3d, std::vector<int> &best_object, dpc::SLAMLocalEgoOdom &vehicle_odom_vec_Temp, double time)
{
    _wrapper(&vehicle_odom_vec_Temp, &vehicle_odom_vec);

    buffer.addData(vehicle_odom_vec);
    buffer.getInterpolatedData(&time, &vehicle_odom_vec);
    // Check if the pointer is valid (not null) before dereferencing.

    for (int num = 0; num < best_object.size(); ++num)
    {
        Usuccess = TUEOBJFUSN_ERROR_NOERROR;
        bboxes_3d(best_object[num], 0) += vehicle_odom_vec.position.x;
        bboxes_3d(best_object[num], 1) += vehicle_odom_vec.position.y;
        bboxes_3d(best_object[num], 2) += vehicle_odom_vec.position.z;
        bboxes_3d(best_object[num], 6) += vehicle_odom_vec.yaw;  
    }

    return;
}

uint32_t mot::InputWrapper::Kinematics_Relative2OverGround( mot::SLAMLocalEgoOdom* vehicle_odom_vec,
    LidarPerceptionOutput* pCurrTrkbl, const float f32deltaX) {

    // Todo: write a syncronization algorithm between ego vehicle and Lidar time stamp

    uint32_t u32Success = TUEOBJFUSN_ERROR_NOERROR;

    //float f32YawRateSq = vehicle_odom_vec->yaw_rate * vehicle_odom_vec->yaw_rate;
    //float f32YawRateTwo = 2.0f * vehicle_odom_vec->yaw_rate;

    /*if ((TUEOBJFUSN_U8COORDSYSTEM_REARAXLE_RELATIVE == pCurrTrkbl.u8CoordSystem) ||
        (TUEOBJFUSN_U8COORDSYSTEM_FRONTBUMP_RELATIVE == pCurrTrkbl.u8CoordSystem))*/
    {
        //uint16_t u16nRows = 4;

        // Use more descriptive variable names
        //float f32PosX = pCurrTrkbl->position.x;
        //float f32PosY = pCurrTrkbl->position.y;
        //float f32PosZ = pCurrTrkbl->position.z;
        //float f32VelX = pCurrTrkbl.vecX.data[TRACKABLE_VELX];
        //float f32VelY = pCurrTrkbl.vecX.data[TRACKABLE_VELY];

        //pCurrTrkbl.vecX.data[TRACKABLE_VELX] = -vehicle_odom_vec->yaw_rate * f32PosY + f32VelX + vehicle_odom_vec->linear_velocity.x;
        //pCurrTrkbl.vecX.data[TRACKABLE_VELY] = vehicle_odom_vec->yaw_rate * f32PosX + f32VelY;

        //if (TRACKABLE_ACCX < u16nRows) {
        //    float f32AccX = pCurrTrkbl.vecX.data[TRACKABLE_ACCX];
        //    pCurrTrkbl.vecX.data[TRACKABLE_ACCX] = (-f32YawRateSq * f32PosX - f32YawRateTwo * f32VelY + f32AccX) + vehicle_odom_vec->f32Acc;
        //}
        pCurrTrkbl->position.x += vehicle_odom_vec->position.x;
        pCurrTrkbl->position.y += vehicle_odom_vec->position.y;
        pCurrTrkbl->position.z += vehicle_odom_vec->position.z;

        pCurrTrkbl->theta += vehicle_odom_vec->yaw;

        pCurrTrkbl->type = "OT_UNKNOWN";
    }
    return u32Success;
}
